#
#  Copyright (c) 2008 INdT - Instituto Nokia de Tecnologia
#
#  This file is part of carman-python.
#
#  carman-python is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  carman-python is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import evas

class GaugeView(evas.SmartObject):

    def __init__(self, canvas):
        """
        Gauges base viewer
        @param canvas: Evas canvas object
        """
        evas.SmartObject.__init__(self, canvas)
        self.clipper = self.Rectangle(size=canvas.size)

    def clip_set(self, obj):
        self.clipper.clip_set(obj)

    def clip_unset(self):
        self.clipper.clip_unset()

    def show(self):
        self.clipper.show()

    def hide(self):
        self.clipper.hide()

    def resize(self, w, h):
        pass

    def set_unit_system(self, min, max, scale, unit):
        pass
